\chapter{Set theory}
\minitoc

Set theory underlies most of modern mathematics, and thus all of analysis. Its
concepts will be of increasing importance as we follow along the construction of
the number systems.

\lecture{4}{Wed 09 Jun 20:11}{Fundamentals}
In this section we will introduce some axioms regarding sets, just as we did for
the natural numbers. Beware, some of the axioms stated below can actually be
deduced from other axioms, though there is no real harm in introducing this
``over-complete set of axioms,'' for they do not introduce any kind of
circularity in further aspects of our theory. To begin with, we have to set an
intuitive idea for what a set is:
\begin{definition}{Informal}{}
        We define a set $A$ to be any unordered collection of objects, e.g.,
        $\{3,8,5,2\}$ is a set. If $x$ is an object, we say that $x$ is an
        element of $A$ or $x \in A$ if $x$ lies in the collection; otherwise, we
        write $x \not\in A$. For instance, $3 \in \{1,2,3,4\}$, but $7 \not\in
        \{1,2,3,4\}$.
\end{definition}

This serves its purpose of being intuitive enough; however, it does not answer a
number of questions, such as what kind of collections classify as sets, or what
operations can be defined on them. Answering these questions will be the purpose
of the following axioms. 

Firstly, we must acknowledge that sets themselves are a type of object:
\begin{axiom}{Sets are objects}{setsare}
        If $A$ is a set, then $A$ is also an object. In particular, given any
        two sets $A$ and $B$, it is meaningful to ask whether $A$ is also an
        element of $B$.
\end{axiom}

E.g., the set $\{3,\{3,4\},4\}$ is a set of three distinct elements, one of
which is itself a set that, in fact, contains the other two elements of the set.
Nevertheless, not all objects are sets, for instance, a natural number is not
typically considered to be a set. 

\begin{remark}{}{}
        There is a special approach to set theory in which all objects are
        regarded as sets; it is called ``pure set theory''. For instance, the
        number 0 might be defined with the empty set $\emptyset = \{\}$, the
        number 1 might be defined by $\{0,1\} = \{ \{\},\{\{\}\} \}$, and so
        forth. This theory is simpler in principle, but it is somewhat more
        intuitive to regard the impure set theory, and since it does not
        contradict this other construction, we shall not be pedantic about the
        topic. 
\end{remark}

Thus far we know that some of the objects studied by mathematics turn out to be
sets themselves. And if we have some object $x$ and some set $A$, then either $x
\in A$ or $x \not\in A$. (Whenever $A$ is not a set, the statement $x \in A$ is
left undefined.) 

Our next step is to define when two sets are equal. Notice that we do not have
to consider order in our definition; thus we think of $\{3,8,5,2\}$ and
$\{2,3,5,8\}$ as being the same set. Conversely , $\{3,8,5,2\}$ and
$\{3,8,5,2,1\}$ are different sets, for the latter has an element which is not
in the former. The following is the formalised definition of set equality:
\begin{definition}{Equality of sets}{equset}
        Two sets $A$ and $B$ are equal, $A = B$, iff every element of $A$ is an
        element of $B$ and vice versa. In other words, $A = B$ if and only if
        every element $x \in A$ also satisfies $x \in B$, and every element $y
        \in B$ also satisfies $y \in  A$.
\end{definition}
 
Thus for instance the sets $\{1\}$ and $\{1,1,1\}$ are the same set, repetition
does not matter as it does not change the fact that 1 is in both sets. One can
easily verify that the equality relation is reflexive symmetric and transitive.
(Left as an exercise). Notice further that if $x \in A$ and $A = B$, then $x \in
B$. Hence the $\in$ relation obeys the \emph{axiom of
substitution}\footnote{This axiom states that if $X = Y$, then $f(X) = f(Y)$ for
all functions and operations $f$. Similarly, if $P(X)$ is some statement
depending on $X$ and $X = Y$, then $P(X)$ and $P(Y)$ are logically equivalent
statements.}, and so will do any operation we define solely in terms of $\in$. 

Now we must define a class of objects that can classify as sets. Analogously to
what we did for the natural numbers, we begin by introducing a single set, the
empty set $\emptyset$, and subsequently building more sets out of the empty set
by various operations. We thus require the following axiom:

\begin{axiom}{Empty set}{empty}
        There exists a set $\emptyset$ known as the empty set, which contains no
        elements, i.e., for every element $x$, we have $x \not\in \emptyset$.
\end{axiom}
The empty set is also denoted $\{\}$. Observe that \textbf{the empty set is
unique}: To prove this, suppose that there are two empty sets $\emptyset$ and
$\emptyset'$; we first want to show that if $x \in \emptyset$, then $x \in
\emptyset'$, but by definition we have $x \not\in \emptyset$, so the statement
is vacuously true. Similarly, we show the converse implication, thus allowing us
to conclude $\emptyset = \emptyset'$, by definition of set equality.

If a set is not the empty set, it can be referred to as non-empty. The following
is a simple consequence of the axioms and definitions presented so far:
\begin{lemma}{Single choice}{}
        Let $A$ be a non-empty set. Then there exists an object $x$ such that $x
        \in A$.
\end{lemma}
\begin{proof}
        Aiming for a contradiction, suppose we have a non-empty set $A$, but for
        which all objects $x$ satisfy $x \not\in A$. Also, by Axiom
        \ref{th:empty}, we have $x \not\in \emptyset$. Thus $x \not\in A \iff x
        \not\in \emptyset$---for both statements are equally false. Hence by
        definition of set equality $A = \emptyset$, a contradiction.
\end{proof}

\begin{remark}{}{}
        The above lemma asserts that we are always allowed to choose an element
        $x$ from a non-empty set. Later on, we will prove that given any finite
        number of non-empty sets $A_1, A_2, \ldots, A_n$, we are allowed to
        choose elements $x_1, x_2, \ldots, x_n$ from each set; this is known as
        ``finite choice''. For choosing elements from an infinite number of
        non-empty sets, we need an additional axiom: \emph{the axiom of choice.} 
\end{remark}

In discussing the empty set $\emptyset$, it is important to keep in mind that it
is completely different from the number 0, though the \emph{cardinality} of the
empty set is actually 0, as we will see in further sections. From this point we
can start enriching our theory with more sets:
\begin{axiom}{Singleton sets and pair sets}{single}
        If $a$ is an object, then there exists a set $\{a\}$ whose only element
        is $a$, i.e., for all objects $y$, we have $y \in \{a\}$ if and only if
        $y = a$; we refer to $\{a\}$ as the \emph{singleton set} whose element
        is $a$. Moreover, if $a$ and $b$ are objects, then there exists a set
        $\{a,b\}$ whose only elements are $a$ and $b$, i.e., for all objects
        $y$, we have $y \in \{a,b\}$ if and only if $y = a$ or $y = b$; this set
        is known as the \emph{pair set} formed by $a$ and $b$.
\end{axiom}

\begin{remark}{}{}
        It is important to note that for each object $a$, the singleton set
        $\{a\}$ is unique, why? Suppose there were two singleton sets $\{a\}$
        and $\{a\}'$, for both of which we have $y$ as an element iff $y = a$.
        Then $y \in \{a\}$ implies $y = a$, which in turn implies $y \in
        \{a\}'$; the converse is shown similarly, thus drawing the conclusion
        that $\{a\} = \{a\}'$.

        Also, given any two objects $a$ and $b$, there is only one pair set
        formed by $a$ and $b$ (the argument is almost exactly the same as the
        one given above). Besides, equality of sets guarantees that $\{a,b\} =
        \{b,a\}$, and that $\{a,a\} = \{a\}$. Hence we see that the singleton
        set axiom is actually a consequence of the pair set axiom. Conversely,
        the pair set axiom is a consequence of the singleton set axiom together
        with the pairwise union axiom stated below. 
\end{remark}

Since $\emptyset$ is a set, it is an object too. Therefore, there exists a
singleton set $\{\emptyset\}$, i.e., the set whose only element is $\emptyset$.
In fact, we have $\emptyset \neq \{\emptyset\}$, for the empty set does not have
any element at all, while the set $\{\emptyset\}$ satisfies $\emptyset \in
\{\emptyset\}$. Similarly, we can form the singleton set $\{ \{\emptyset\}
\}$and the pair set  $\{\emptyset, \{\emptyset\}\}$. These three sets are not
equal to each other (Left as an exercise).

The next axiom allows us to write ``greater'' sets, which can have more than two
elements:
\begin{axiom}{Pairwise union}{union}
        Given any two sets $A$, $B$, there exists a set $A \cup B$ of $A$ and
        $B$, whose elements consist of all the elements which belong to $A$ or
        $B$ or both. In other words, for any object $x$:
        \[
                x \in A \cup B \iff (x \in A \text{ or } x \in B).
        \] 
\end{axiom}
So for instance $\{1,2,3\} \cup \{3,4\} = \{1,2,3,4\}$.
\begin{remark}{}{}
        If $A, B,$ and $A'$ are sets, and $A = A'$, then we have $A \cup B = A'
        \cup B$: Note that if $x \in A \cup B$, then $x \in A$ or $x \in B$;
        proceeding by cases: Suppose that $x \in B$, then Axiom \ref{th:union}
        implies $x \in A' \cup B$; on the other hand, if $x \in A$, then the
        hypothesised equality tells us that $x \in A'$, so we have $x \in A'
        \cup B$, as desired. A similar argument shows the converse implication,
        completing the proof.

        Thus the union operation obeys the axiom of substitution, so it is
        well-defined on sets. 
\end{remark}            

We now turn to various properties of unions:

\begin{lemma}{}{}
        If $a$ and $b$ are objects, then $\{a,b\} = \{a\} \cup \{b\}$. If
        $A,B,C$ are sets, then the union operation is commutative, i.e., $A \cup
        B = B \cup A$, and associative, i.e., $(A \cup B) \cup C = A \cup (B
        \cup C)$. Moreover, we have $A \cup A = A \cup \emptyset = \emptyset
        \cup A = A$. 
\end{lemma}
\begin{proof}
        We provide the proof of associativity, the rest is left as an exercise.
        By definition of set equality, we want to show that if $x \in (A \cup B)
        \cup C$, then $x \in A \cup (B \cup C)$, and vice versa. 
 
        Suppose first that $x \in (A \cup B) \cup C$, then we know by Axiom
        \ref{th:union} that at least one of the following statements is true: $x
        \in A \cup B$ or $x \in C$. Now we proceed by cases; first, if $x \in
        C$, then we know by pairwise union axiom that $x \in B \cup C$ (because
        $x \in B$ or $x \in C$ would be true), and then again (by the same
        axiom) that $x \in A \cup (B \cup C)$. On the other hand, if $x \in A
        \cup B$, then by Axiom \ref{th:union} we have $x \in A$ or $x \in B$, if
        $x \in A$, then we can subsequently apply the axiom on pairwise union to
        get $x \in A \cup (B \cup C)$; and if $x \in B$, the same axiom implies
        $x \in A \cup (B \cup C)$. Hence in every case we see that an element of
        $(A \cup B) \cup C$ is also an element of $A \cup (B \cup C)$. 

        A similar argument shows that every element in $A \cup (B \cup C)$ lies
        in $(A \cup B) \cup C$.
\end{proof}

Because of the above lemma, the expression $A \cup B \cup C$ is well defined on
sets; similarly, unions of four sets $A \cup B \cup C \cup D$, and so forth.

Now this axiom allows us to write triplet sets, quadruplet sets, etc.: if
$a,b,c$ are any three objects, we define $\{a,b,c\} = \{a\} \cup \{b\} \cup
\{c\}$; if $a,b,c,d$ are any four objects, we define $\{a,b,c,d\} = \{a\} \cup
\{b\} \cup \{c\} \cup \{d\}$, and so on. On the other hand, we are not yet in a
position to define sets consisting of $n$ objects given a natural number $n$;
that would effectively require iterating the above construction $n$ times, but
the concept of $n$-fold iterations has not yet been formally defined. For
similar reasons, we cannot define sets consisting of infinitely many sets
---that would require an infinite iteration over the pairwise union axiom (!).
Later on we will introduce the necessary axioms for such purposes.

Clearly, there ought to be some notion of ``magnitude'' for sets, that is, some
sets appear to be larger than others. A way to formalise this concept is through
the notion of subset:
\begin{definition}{Subsets}{}
        Let $A, B$ be sets. We say that $A$ is a \emph{subset} of $B$, $A
        \subseteq B$, iff every element of $A$ is also an element of $B$, i.e.,
        \[
        \text{for any object $x$,} \quad x \in A \implies x \in B.
        \] 
        We say that $A$ is a \emph{proper subset} of $B$, $A \subsetneq B$, if
        $A \subseteq B$ and $A \neq B$.
\end{definition}
\begin{remark}{}{}
        Because these definitions involve only the notions of equality and the
        ``is an element of'' relation, both of which already obey the axiom of
        substitution, the notion of subset automatically obeys the axiom of
        substitution. Thus for instance: if $A \subseteq B$  and $A = A'$, then
        $A' \subseteq B$.
\end{remark}

As an example, we have $\{1,2,4\} \subseteq \{1,2,3,4,5\}$, because every
element of $\{1,2,4\}$ is also an element of $\{1,2,3,4,5\}$. In fact, we have
$\{1,2,4\} \subsetneq \{1,2,3,4,5\}$, because these sets are not equal. Also,
given any set $A$, we have $A \subseteq A$ (because if $x \in A$ it is very
obviously true that $x \in A$) and $\emptyset \subseteq A$ (because $x \in
\emptyset$ is always false, so the implication is vacuously true). 

The notion of subset in set theory is similar to the notion of ``less than or
equal to'' for numbers, as the following proposition will show:
\begin{proposition}{Sets are partially ordered by set inclusion}{}
        Let $A,B,C$ be sets. If $A \subseteq B$ and $B \subseteq C$, then $A
        \subseteq C$. If $A \subseteq B$ and $B \subseteq A$, then $A = B$.
        Finally, if  $A \subsetneq B$ and $B \subsetneq C$, then $A \subsetneq
        C$
\end{proposition}
\begin{proof}
        We shall just prove the first claim. Suppose that $A \subseteq B$ and $B
        \subseteq C$. To prove that $A \subseteq C$, we assume $x \in A$, then
        by the hypothesis we know that $x \in B$, and once again by hypothesis
        this implies $x \in C$. Thus every element of $A$ is also an element of
        $C$, as claimed. 
\end{proof}
\begin{remark}{}{}
        There exists a relationship between subsets and unions, see for instance
        the 7th exercise of this section.
\end{remark}

\begin{remark}{}{}
        We must note that sets are different from their elements: $\{2\} \neq
        2$, which also implies that we \emph{cannot} say $2 \subseteq \{2\}$,
        for 2 is not itself a set. This distinction is crucial, for sets and
        their elements can have wildly different properties, for example, there
        are infinite sets consisting of finite elements ($\mathbb{N}$ is one
        such set), and there are also finite sets consisting of infinite
        elements (take for instance $\{\mathbb{N, Z, Q, R}\}$.
\end{remark}

We now give an axiom that easily allows us to create new subsets out of larger
sets:
\begin{axiom}{Axiom of specification}{}
        Let $A$ be a set, and let $P(x)$ be a property pertaining to $x$ for
        each  $x \in A$ ($P(x)$ is either true or false). Then there exists a
        set, called $\{x \in A : P(x) \text{ is true}\}$ (or simply abbreviated
        $\{x \in A : P(x)\}$), whose elements are precisely the elements $x$ in
        $A$ for which $P(x)$ is true. In other words, for any object $y$:
        \[
                y \in \{x \in A : P(x) \text{ is true}\} \iff (y \in A \text{
                and } P(y) \text{ is true}).
        \] 
\end{axiom}
This axiom is also known as the \emph{axiom of separation}. Note that $\{x \in A
: P(x) \text{ is true}\}$ is always a subset of $A$: Pick an element $y \in \{x
\in A : P(x)\}$, we know that $P(y)$ is necessarily true and that $y \in A$,
which proves our claim. However, note that the set $\{x \in A : P(x)\}$ could be
as large as $A$ (if $P(x)$ is true for all  $x \in A$) or as small as the empty
set (if $P(x)$ is false for all $x \in A$). One can verify that the axiom of
substitution works for specification, i.e., if $A = A'$, then $\{x \in A :
P(x)\} = \{x \in A' : P(x)\}$: In that case we can pick any element $y \in \{x
\in A : P(x)\}$ and see that it must satisfy $P(y)$ and $y \in A$, but this
implies by definition of set equality that $y \in A'$ (and we already know that
$P(y)$ is true); the converse is shown analogously, thus completing the proof of
this claim.

As an example, we can define $S := \{1,2,3,4,5\}$; then the set $\{n \in S : n <
4\}$ is the set of those elements $n$ in $S$ for which $n < 4$ is true, i.e.,
$\{1,2,3\}$.

We sometimes write a set by specification as $\{x \in A \mid P(x)\}$, this
notation is useful when the colon is used to denote anything else (for instance,
a function $f : X \to Y$. 

We can now use specification to define other operations on sets:
\begin{definition}{Intersections}{}
        The \emph{intersection} $S_1 \cap S_2$ of two sets is defined to be the
        set 
        \[
                S_1 \cap S_2 := \{x \in S_1 : x \in S_2\}.
        \] 
        In other words, $S_1 \cap S_2$ consists of all the elements which belong
        to both $S_1$ and $S_2$. Thus, for all objects $x$,
         \[
                 x \in S_1 \cap S_2 \iff (x \in S_1 \text{ and } x \in S_2).
        \] 
\end{definition}

We should for example acknowledge that $\{2,3\} \cap \emptyset = \emptyset$.
Also, beware of the use of words such as ``and'' in English, for they can have
multiple meanings (!). 

Two sets $A, B$ are said to be \emph{disjoint} if $A \cap B = \emptyset$. Note
that this is not the same as being \emph{distinct}, $A \neq B$ the sets
$\{1,2,3\}$ and $\{2,3,4\}$ are distinct, but not disjoint. Meanwhile, the sets
$\emptyset$ and $\emptyset$ are disjoint, but not distinct: For one thing, we
know $\emptyset$ is unique and that no object can possibly be an element of
$\emptyset$.

\begin{definition}{Difference sets}{}
        Given two sets $A$ and $B$, we define the set $A \setdif B$ to be the
        set $A$ with any elements of $B$ removed:
        \[
        A \setdif B := \{x \in A : x \not\in B\}.
        \]
\end{definition}
For instance, $\{1,2,3,4\} \setdif \{2,4,6\} = \{1,3\}$. In many cases, $B$ will
be a subset of $A$, but not necessarily.

With what we have defined so far, we can introduce basic properties of unions,
intersections, and difference sets:
\begin{proposition}{Sets form a boolean algebra}{}
        Let $A, B, C$ be sets, and let $X$ be a set containing $A, B, C$ as
        subsets: $A,B,C \subseteq X$. Then 
        \begin{itemize}
                \item (Minimal element) We have $A \cup \emptyset = A$ and $A
                        \cap \emptyset = \emptyset$.
                \item (Maximal element) We have $A \cup X = X$ and $A \cap X =
                        A$.
                \item (Identity) We have $A \cap A = A$ and $A \cup A = A$.
                \item (Commutativity) We have $A \cup B = B \cup A$ and $A \cap
                        B = B \cap A$. 
                \item (Associativity) We have $(A \cup B) \cup C = A \cup (B
                        \cup C)$ and $(A \cap B) \cap C = A \cap (B \cap C)$.
                \item (Distributivity) We have $A \cap (B \cup C) = (A \cap B)
                        \cup (A \cap C)$ and $A \cup (B \cap C) = (A \cup B)
                        \cap (A \cup C)$.
                \item (Partition) We have $A \cup (X \setdif A) = X$ and $A \cap
                        (X \setdif A) = \emptyset$.
                \item (DeMorgan laws) We have $X \setdif (A \cup B) = (X \setdif
                        A) \cap (X \setdif B)$, and $X \setdif (A \cap B) = (X
                        \setdif A) \cup (X \setdif B)$.
        \end{itemize}
\end{proposition}
\begin{proof}
        Left as an exercise.
\end{proof}

\begin{remark}{}{}
        We may observe a certain symmetry in the above laws between $\cup$ and
        $\cap$, and between $X$ and $\emptyset$. This is an example of duality.
        In this case the duality is manifested by the \emph{complementation}
        operation $A \mapsto X \setdif A$ (which converts a set $A$ into its
        complement); the DeMorgan laws assert that this relation converts unions
        into intersections and vice versa; it also exchanges $X$ and the empty
        set $\emptyset$. 
\end{remark}

The next axiom serves to transform sets element-wise. That is, if we have a set
$\{3,4,5\}$, we could obtain a new set by incrementing each element in the set
by 1: $\{4,5,6\}$. We cannot do this directly from the axioms thus far
introduced, hence we introduce the following:
\begin{axiom}{Replacement}{}
        Let $A$ be a set. For any object $x \in A$ and any object $y$, suppose
        we have some statement $P(x,y)$ pertaining to $x$ and $y$ such that for
        each $x \in A$ there is \emph{at most one} $y$ for which $P(x,y)$ is
        true. Then there exists a set $\{y : P(x,y) \text{ is true for some } x
        \in A\}$, such that for any object $z$: 
        \begin{multline*}
                        z \in \{y : P(x,y) \text{ is true for some } x \in A\} \\ 
                        \iff P(x,z) \text{ is true for some } x \in A.
                        \end{multline*}
\end{axiom}

For instance, let $A := \{3,5,9\}$, and let $P(x,y)$ be the statement $y =
x\pp$, that is, $y$ is the successor of $x$. Note that for each $x \in A$ there
is exactly one $y$ for which $P(x,y)$ is true ---indeed, the successor is
unique. Thus the above axiom guarantees the existence of the set $ \{y : y =
x\pp \text{ for some } x \in A\} $. In this case, it is clearly the same as the
set $\{4,6,10\}$, why? Because if an object $z$ is in $\{y : y = x\pp \text{ for
some } x \in A\}$, then we have $P(x,z)$ is true for some $x \in A$, that is: $z
= 3\pp$, or  $z = 5\pp$, or $z = 9\pp$; in either case, we see that $z \in
\{4,6,10\}$. The converse is obviously true from the definition given in the
axiom of replacement, since any object $z \in \{4,6,10\}$ satisfies $z = x\pp$
for some $x \in A$.

As another example, take the same set, $A = \{3,5,9\}$, and let $P(x,y)$ be the
statement $y = 1$. Then again, for every $x \in A$, there is exactly one $y$
satisfying $P(x,y)$ (precisely the number 1). In this case  $ \{y : y = 1 \text{
for some } x \in A\}$ is just the singleton set $\{1\}$. Thus we see that a set
obtained by replacement can be ``smaller'' that the original set.

We often abbreviate sets of the form 
\[
        \{y : y = f(x) \text{ for some } x \in A\} 
\] 
as $ \{f(x) : x \in A\} $ or $\{f(x) \mid x \in A\} $. Thus, for example, if $A
= \{3,5,9\}$, then $\{x\pp : x \in A\}$ is the set $\{4,6,10\}$. We can also
combine the axiom of specification with the axiom of replacement to create sets
such as $\{f(x) : x \in A \text{ and } P(x) \text{ is true}\}$ by starting with
the set $A$, using specification to create the set $ \{x \in A : P(x) \text{ is
true}\}$, and then applying replacement to create $\{y : y = f(x) \text{ for
some } x \in A; P(x) \text{ is true}\}$, which can be abbreviated as shown,
$\{f(x) : x \in A \text{ and } P(x) \text{ is true}\}$. As a specific example, $
\{n\pp : n \in \{3,5,9\}; n < 6\} = \{4,6\}$.

In many of our examples, we have assumed that natural numbers are objects, we
formalise that statement:
\begin{axiom}{Infinity}{}
        There exists a set $\mathbb N$, whose elements are called natural
        numbers, as well as an object 0 in $\mathbb N$, and an object $n\pp$
        assigned to every natural number $n \in \mathbb N$, such that the Peano
        axioms hold.
\end{axiom}

Recall that the concept of a set must be kept distinct from the elements of that
set. For instance, the set $\{n+3 : n \in \mathbb N; 0 \le n \le 5\}$ is not the
same thing as the expression $n + 3$.

TODO: Last example. 

\subsection{Exercises}
\begin{exercise}
        Show that the definition of set equality is reflexive, symmetric, and
        transitive.
\end{exercise}
\begin{itemize}
        \item (Reflexivity) $A = A$
                \begin{proof}
                        Obviously, $x \in A$ iff $x \in A$ ---that is to say,
                        every element of $A$ is also in $A$. Hence $A = A$.
                \end{proof}
        \item (Symmetry) If $A = B$, then $B = A$.
                 \begin{proof}
                         Obviously, saying $x \in A$ iff $x \in B$ is logically
                         equivalent to saying $x \in B$ iff $x \in A$, so the
                         result follows immediately. 

                         More explicitly, suppose that $A = B$, then if an
                         object satisfies $x \in B$, definition of equality
                         tells us that $x \in A$, and if any object satisfies $x
                         \in A$, then $x \in B$; whence $B = A$. 
                \end{proof}
        \item (Transitivity) If $A = B$ and $B = C$, then  $A = C$
                \begin{proof}
                        If $A = B$ and $B = C$, then we see that $x \in A$
                        implies $x \in B$, and $x \in B$ implies $x \in C$; thus
                        if $x \in A$, then $x \in C$. Conversely, if $x \in C$,
                        we see that $x \in B$, and this in turn implies that $x
                        \in A$; thus if $x \in C$, then $x \in A$. This
                        completes the proof, because $A$ and $C$ have exactly
                        the same elements: $A = C$.
                \end{proof}
\end{itemize}

\begin{exercise}
        Using only the definition of set equality, and Axioms \ref{th:setsare},
        \ref{th:empty}, \ref{th:single}, prove that the sets $\emptyset$, $
        \{\emptyset\}$, $\{ \{\emptyset\} \}$, and $\{\emptyset, \{\emptyset\}
        \}$ are all distinct.
\end{exercise}
\begin{proof}
        Firstly, we show that $\emptyset \neq \{\emptyset\}$, $\emptyset \neq
        \{\{\emptyset\}\}$, and $\emptyset \neq \{\emptyset, \{\emptyset\}\}$.
        The first inequality amounts to showing that there is some object $x$
        that satisfies either $x \in \emptyset$ but $x \not\in \{\emptyset\}$,
        or $x \not\in \emptyset$ but $x \in \{\emptyset\}$ (this is the negation
        of equality, as presented by definition). The former statement is always
        false by Axiom \ref{th:empty} (no object is an element of $\emptyset$);
        whereas the latter statement is true for $\emptyset$, that is:
        $\emptyset \not\in \emptyset$, because for all objects $n$ we have $n
        \not\in \emptyset$ (it turns out that sets are objects (Axiom
        \ref{th:empty}) and the empty set is a set (Axiom \ref{th:empty})), and
        because $\{\emptyset\}$ is defined as the singleton set containing the
        object $\emptyset$, so Axiom \ref{th:single} tells us that $\emptyset
        \in \{\emptyset\}$. Whence $\boxed{\emptyset \neq \{\emptyset\}.}$
        Similarly, we have $\{\emptyset\} \in \{ \{\emptyset\} \} $ (by the
        axiom on singleton sets), but $\{\emptyset\} \not\in \emptyset$ (by the
        axiom on the empty set); which implies that $\boxed{\emptyset \neq \{
        \{\emptyset\}\}.}$ Besides, $\emptyset \in \{\emptyset, \{\emptyset\}
\}$, by definition of pair set, but $\emptyset \not\in \emptyset$, so
$\boxed{\emptyset \neq \{\emptyset, \{\emptyset\}\}}$

        Now we wish to prove that $\{\emptyset\} \neq \{\{\emptyset\}\}$ and
        $\{\emptyset\} \neq \{\emptyset, \{\emptyset\}\}$. To begin with, notice
        that $x \in \{\emptyset\}$ iff $x = \emptyset$, by singleton set axiom;
        also, we have $x \in \{ \{\emptyset\} \}$ iff $x = \{\emptyset\}$.
        Nevertheless, we have already shown that $\emptyset \neq \{\emptyset\}$,
        which is to say: $\emptyset \in \{\emptyset\}$, but $\emptyset \not\in
        \{\{\emptyset\}\}$. Now, this means $\boxed{\{\emptyset\} \neq
        \{\{\emptyset\}\}.}$ On a similar fashion, we know that $x \in
        \{\emptyset, \{\emptyset\}\}$ iff $x = \emptyset$ or  $x =
        \{\emptyset\}$, hence $\{\emptyset\} \in \{\emptyset, \{\emptyset\}\}$,
        but $\{\emptyset\} \not\in \{\emptyset\}$. This means that
        $\boxed{\{\emptyset\} \neq \{\emptyset, \{\emptyset\}\}.}$

        Finally, in order to prove $\{\{\emptyset\}\} \neq \{\emptyset,
        \{\emptyset\}\}$, we should acknowledge that $\emptyset \in \{\emptyset,
\{\emptyset\}\}$, but $\emptyset \not\in \{\{\emptyset\}\}$; this means that
$\boxed{\{\{\emptyset\}\} \neq \{\emptyset, \{\emptyset\}\},}$ completing the
proof.
\end{proof}

\begin{exercise}
        Show the remaining claims in Lemma 2.1.2.
\end{exercise}
This exercise is asking us to prove that $\{a,b\} = \{a\} \cup \{b\}$, that the
union operation is commutative, and that $A \cup A = A \cup \emptyset =
\emptyset \cup A = A$.
\begin{proof}
        We first show that $\{a,b\} = \{a\} \cup \{b\}$. Suppose on the one hand
        that $x \in \{a,b\}$, then by Axiom \ref{th:single}, we have $x = a$ or
        $x = b$; by cases: If $x = a$, then singleton set Axiom (\ref{th:single}
        implies that $x \in \{a\}$, and so $x \in \{a\} \cup \{b\}$; if $x = b$,
        the same axiom tells us that $x \in \{b\}$, so by definition $x \in
        \{a\} \cup \{b\}$. On the other hand, whenever $x \in \{a\} \cup \{b\}$,
        we have $x \in \{a\}$ or $x \in \{b\}$; if the former is true, then $x =
        a$, so  $x \in \{a,b\}$ (pair set axiom); if the latter is true, then $x
        = b$, which is to say $x \in \{a,b\}$. Hence every element of $\{a,b\}$
        is also an element of $\{a\} \cup \{b\}$, and vice versa: $\{a,b\} =
        \{a\} \cup \{b\}$.
        
        Now the union operation is commutative: Let $x \in A \cup B$, then we
        know that $x \in A$ or $x \in B$. If $x \in A$, then definition of union
        tells us that $x \in B \cup A$; if $x \in B$, the same definition
        implies $x \in B \cup A$. Thus every object which is an element of $A
        \cup B$ is also an element of $B \cup A$. The converse is shown
        analogously, hence the result: $A \cup B = B \cup A$.

        Finally, to prove the string of equalities we proceed as follows:
        \begin{itemize}
                \item If $x \in A \cup A$, then $x \in A$ or $x \in A$. But,
                        then $x \in A$, which is to say an element of $A \cup A$
                        is always in $A$. On the other hand, if $x \in A$, then
                        $x \in A \cup A$. Hence $A \cup A = A$, as desired.
                \item If $x \in A \cup \emptyset$, then $x \in A$ or $x \in
                        \emptyset$. But we know $n \not\in \emptyset$, for all
                        objects $n$, which leaves us with $x \in A$. Conversely,
                        if $x \in A$, then $x \in A \cup \emptyset$, by
                        definition. Thus $A \cup \emptyset = A$.
                \item Commutativity implies $ A = A \cup \emptyset = \emptyset
                        \cup A$.
        \end{itemize}
        This completes the proof.
\end{proof}

\begin{exercise}
        Prove the remaining claims in Proposition 2.1.1.
\end{exercise}
We need to show that if $A \subseteq B$ and $B \subseteq A$, then $A = B$, and
that if $A \subsetneq B$ and $B \subsetneq C$, then $A \subsetneq C$.
\begin{proof}
        First, suppose $A \subseteq B$ and $B \subseteq A$, then we have $x \in
        A \implies x \in B$, and $x \in B \implies x \in A$, but this is just
        the definition of set equality, so $A = B$.

        Finally, suppose that $A \subsetneq B$ and $B \subsetneq C$, then if $x
        \in A$, we have $x \in B$; this implies that $x \in C$, which shows $A
        \subseteq C$. Now we wish to prove $A \neq C$. Note that $B \neq C$, so
        there is some object $y$, such that $y \in C$, but $y \not\in B$ ($y \in
        B$ and $y \not\in C$ is impossible, since then $y \in B$ would not imply
        $y \in C$, thus contradicting the definition of strict contention). Also
        $A \subsetneq B$, which is to say that for every $x$,  $x \in A \implies
        x \in B$; by contrapositive this is equivalent to $x \not\in B \implies
        x \not\in A$. Thus $y \in C$ and $y \not\in B$ implies $y \not\in A$:
        $y$ is an object which is an element of $C$, but is not an element of
        $A$: $A \neq C$, as desired. We conclude $A \subsetneq C$.
\end{proof}

\begin{exercise}
        Let $A, B$ be sets. Show that the three statements $A \subseteq B$, $A
        \cup B = B$, $A \cap B = A$ are logically equivalent (any one of them
        implies the other two). 
\end{exercise}
There is a usual way to prove this kind of statements: In this case we show $A
\subseteq B \implies A \cup B = B \implies A \cap B = A \implies A \subseteq B$
\begin{proof}
        Firstly, suppose that $A \subseteq B$, i.e., $x \in A \implies x \in B$.
        Then if $x \in A \cup B$, we have $x \in A$ or $x \in B$. By cases: If
        $x \in A$, then we know by hypothesis that $x \in B$; if $x \in B$, then
        $x \in B$ (obviously). Hence if $x \in A \cup B$, then $x \in B$. Also,
        if $x \in B$, then $x \in A \cup B$, by definition of union. We thus
        conclude that $A \cup B = B$ whenever $A \subseteq B$. 
        
        Secondly, suppose that $A \cup B = B$. Then if $x \in A \cap B$, we have
        $x \in A$ and $x \in B$, so (obviously) $x \in A$. On the other hand, if
        $x \in A$, then $x \in A \cup B$; the hypothesised equality now tells us
        that $x$ also satisfies $x \in B$. Hence $x \in A$ implies $x \in A \cap
        B$. In general, $A \cap B = A$ whenever $A \cup B = B$. 

        Finally, suppose that $A \cap B = A$. Then if $x \in A$ we have $x \in
        A$ and $x \in B$. Hence $A \subseteq B$, as desired. This completes the
        proof.
\end{proof}

\begin{exercise}
        Prove Proposition 2.1.2. (Hint: One can use some of these claims to
        prove others. Some of the claims have also appeared previously in Lemma
        2.1.2.)
\end{exercise}
We have to prove eight statements:
\begin{itemize}
        \item Minimal element; we have $A \cup \emptyset = A$ and $A \cap
                \emptyset = \emptyset$.
                \begin{proof}
                        The first statement was shown as part of Lemma 2.1.2; $A
                        \cup \emptyset = A$. As for the second one, suppose that
                        $x \in A \cap \emptyset$, this means that $x \in A$ and
                        $x \in \emptyset$; since the assumption $x \in
                        \emptyset$ is always false (by axiom on empty set), we
                        note that $x \in A \cap \emptyset \implies x \in
                        \emptyset$ is vacuously true. Similarly, one can prove
                        the converse implication (which is also vacuously true),
                        thus leaving us with $A \cap \emptyset = \emptyset$.
                \end{proof}
        \item Maximal element; we have $A \cup X = X$, and $A \cap X = A$.
                \begin{proof}
                        For the first statement: Suppose $x \in A \cup X$, then
                        $x \in A$ or $x \in X$; if $x \in A$, we know $x \in X$
                        because $A \subseteq X$; and if $x \in X$, then $x \in
                        X$ (obviously). Conversely, assume $x \in X$, then by
                        axiom on pairwise union we have $x \in A \cup X$.

                        For the second statement: If $x \in A \cap X$, then $x
                        \in A$ and $x \in X$; but since $A \subseteq X$, we just
                        have $x \in A$. Conversely, if $x \in A$, then $x \in
                        X$. Hence $A \cap X = A$.
                \end{proof}
        \item Identity; $A \cap A = A$ and $A \cup A = A$.
                \begin{proof}
                        By definition, if $x \in A \cap A$, then $x \in A$.
                        Also, if $x \in A$, then obviously $x \in A$ and $x \in
                        A$. Hence $A \cap A = A$. On the other hand, if $x \in A
                        \cup A$, we have $x \in A$ or $x \in A$, so in either
                        case $x \in A$ (obviously). Finally, if $x \in A$, we
                        have $x \in A$ or $x \in A$. Meaning that $A \cup A =
                        A$.
                \end{proof}
        \item Commutativity; $A \cup B = B \cup A$ and $A \cap B = B \cap A$. 
                \begin{proof}
                        The proof of commutativity for unions $\cup$ has already
                        been shown as part of Lemma 2.1.2. As for intersections,
                        we proceed as follows: Take $x \in A \cap B$, then we
                        know that $x \in A$ and $x \in B$, which is to say $x
                        \in B \cap A$ (by definition). The converse is
                        analogous. 
                \end{proof}
        \item Associativity; $(A \cup B) \cup C = A \cup (B \cup C)$ and $(A
                \cap B) \cap C = A \cap (B \cap C)$ 
                \begin{proof}
                        The proof of associativity for unions $\cup$ has already
                        been shown as part of Lemma 2.1.2. We prove the
                        statement for intersections. Suppose first that $x \in
                        (A \cap B) \cap C$, this means that $x \in A \cap B$ and
                        $x \in C$, which in turn means that $x \in A$, $x \in B$
                        and $x \in C$; however, definition of set intersection
                        tells us that this is equivalent to $x \in A$ and $x \in
                        B \cap C$, or $x \in A \cap (B \cap C)$, as desired. The
                        converse is shown analogously, thus completing the
                        proof.
                \end{proof}
        \item Distributivity; $A \cap (B \cup C) = (A \cap B) \cup (A \cap C)$
                and $A \cup (B \cap C) = (A \cup B) \cap (A \cup C)$.
                \begin{proof}
                        Suppose first that $x \in A \cap (B \cup C)$, then $x
                        \in A$ and $x \in B \cup C$. There are two cases: If $x
                        \in A$ and $x \in B$, then we have $x \in A \cap B$ by
                        definition of intersection; then, by definition of
                        pairwise union, we have $x \in (A \cap B) \cup (A \cap
                        C)$. If $x \in A$ and $x \in C$, then $x \in A \cap C$
                        by definition of intersection; which is to say $x \in (A
                        \cap B) \cup (A\cap C)$. Hence in either case $x \in (A
                        \cap B) \cup (A \cap C)$, as desired. Now, if $x \in (A
                        \cap B) \cup (A \cap C)$, then we have $x \in A \cap B$
                        or $x \in A \cap C$: If $x \in A \cap B$, then we have
                        $x \in A$ and $x \in B$; hence $x \in A$ and $x \in B
                        \cup C$ (by definition of pairwise union), this means
                        that $x \in A \cap (B \cup C)$. Similarly, if $x \in A
                        \cap C$, then we have $x \in A$ and $x \in C$, so $x \in
                        A$ and $x \in B \cup C$: $x \in A \cap (B \cup C)$. This
                        completes the proof that $A \cap (B \cup C) = (A \cap B)
                        \cup (A \cap C)$.

                        Next, suppose that $x \in A \cup (B \cap C)$, then $x
                        \in A$ or $x \in B \cap C$. If $x \in A$, then $x \in A
                        \cup B$ and $x \in A \cup C$, by definition of pairwise
                        union; hence $x \in (A \cup B) \cap (A\cup C)$. On the
                        other hand, if $x \in B \cap C$, then $x \in B$ and $x
                        \in C$; by definition of pairwise union, this means that
                        $x \in A \cup B$ and also $x \in A \cup C$; thus $x \in
                        (A \cup B) \cap (A \cap C)$, as desired. Now, if $x \in
                        (A \cup B) \cap (A \cap C)$, then $x \in A \cup B$ and
                        $x \in A \cup C$: If $x \in A$ and $x$ is an element of
                        any of the other sets, then $x \in A \cup (B \cap C)$,
                        by definition of pairwise union; and if $x \in B$ and $x
                        \in C$, this means $x \in B \cap C$, so $x \in A \cup (B
                        \cap C)$. This completes the proof that $A \cup (B \cap
                        C) = (A \cup B) \cap (A \cap C)$.
                \end{proof}
        \item Partition; $A \cup (X \setdif A) = X$ and $A \cap (X \setdif A) =
                \emptyset$.
                \begin{proof}
                        Assuming $x \in A \cup (X \setdif A)$, we have $x \in A$
                        or $x \in X \setdif A$. If $x \in A$, then $x \in X$
                        (because $A \subseteq X$); and if $x \in X \setdif A$,
                        then $x \in X$ by definition of difference set. Hence in
                        either case $x \in X$. Conversely, if $x \in X$, then we
                        have two cases: Either $x \in X$ and $x \in A$, or $x
                        \in X$ and $x \not\in A$. If $x \in A$, then we know $x
                        \in A \cup (X \setdif A)$, by definition of pairwise
                        union; and if $x \not\in A$, we have $x \in X \setdif A$
                        by definition of difference set; thus $x \in A \cup (X
                        \setdif A)$ by definition of pairwise union. This
                        completes the proof that $A \cup (X \setdif A) = X$.

                        For the next statement we wish to prove that $x \in A
                        \cap (X \setdif A) \iff x \in \emptyset$. If we suppose
                        $x \in A \cap (X \setdif A)$, then we would have $x \in
                        A$ and $x \in X$, but $x \not\in A$, which is
                        contradictory; thus the implication $x \in A \cap (X
                        \setdif A) \implies x \in \emptyset$ is vacuously true.
                        The converse implication is also vacuously true, so the
                        result follows.
                \end{proof}
        \item DeMorgan laws; $X \setdif (A \cup B) = (X \setdif A) \cap (X
                \setdif B)$ and $X \setdif (A \cap B) = (X \setdif A) \cup (X
                \setdif B)$.
                \begin{proof}
                        Suppose that $x \in X \setdif (A \cup B)$, then we have
                        $x \in X$, but $x \not\in A \cup B$, which is to say $x
                        \not\in A$ and $x \not\in B$. Hence $x \in X$, but $x
                        \not\in A$, and $x \in X$, but $x \not\in B$, this means
                        that $x \in (X \setdif A) \cap (X \setdif B)$b y
                        definition of set difference. Conversely, if $x \in (X
                        \setdif A) \cap (X \setdif B)$.
                \end{proof}
\end{itemize}

\begin{exercise}
        Let $A, B, C$ be sets. Show that $A \cap B \subseteq A$ and $A \cap B
        \subseteq B$. Furthermore, show that $C \subseteq A$ and $C \subseteq B$
        if and only if $C \subseteq A \cap B$.
        
        In a similar spirit, show that $A \subseteq A \cup B$ and $B \subseteq A
        \cup B$, and furthermore that $A \subseteq C$ and $B \subseteq C$ if and
        only if $A \cup B \subseteq C$.
\end{exercise}
\begin{proof}
        We prove both statements:
        \begin{itemize}
                \item If $x \in A \cap B$, then $x \in A$ by definition of
                        pairwise intersection. Similarly, if $x \in A \cap B$,
                        then $x \in B$. For the second part of the statement:
                        Suppose first that $C \subset A$ and $C \subset B$, and
                        take $x \in C$, then we know that $x \in A$ and $x \in
                        B$, which means $x \in A \cap B$.
                \item This is shown similarly. 
        \end{itemize}
        This completes the proof.
\end{proof}

\begin{exercise}
        Let $A, B$ be sets. Prove the absorption laws $A \cap (A \cup B) = A$
        and $A \cup (A \cap B) = A$.
\end{exercise}
\begin{proof}
        To begin with, note that $A \subseteq A \cup B$, thus $A \cap (A \cup B)
        = A$ by intersection with maximal element (Proposition 2.1.2). On the
        other hand, $A \cap B \subseteq A$, so $A \cup (A \cap B) = A$ by union
        with maximal element (Proposition 2.1.2).
\end{proof}

\begin{exercise}
        Let $A,B,X$ be sets such that $A \cup B = X$ and $A \cap B = \emptyset$.
        Show that $A = X \setdif B$ and  $B = X \setdif A$.
\end{exercise}
\begin{proof}
        If $x \in A$, then $x \in A \cup B$, so $x \in X$ by hypothesis. Now,
        there are two possibilities: Either $x \in X$ and $x \in B$, or $x \in
        X$ and $x \not\in B$. Supposing $x \in B$ yields a contradiction, for in
        that case $x \in A \cap B$, but $A \cap B = \emptyset$. Hence we require
        that $x \in X$ and $x \not\in B$, so $x \in X \setdif B$. Now, if $x \in
        X \setdif B$, then $x \in X$, but $x \not\in B$; $x \in X$ means that $x
        \in A \cup B$ by hypothesis; but since $x \not\in B$, we are only left
        with $x \in A$, as desired. The other equality is shown analogously.
\end{proof}

\begin{exercise}
        Let $A$ and $B$ be sets. Show that $A \setdif B, A \cap B,$ and $B
        \setdif A$ are disjoint, and that their union is $A \cup B$.
\end{exercise}
\begin{proof}
        To show that the sets are disjoint, it suffices to prove that assuming
        $x \in (A \setdif B) \cap (A \cap B) \cap (B \setdif A)$ yields a
        contradiction. Indeed, a consequence thereof is that $x \not\in B$ and
        $x \in B$, which is evidently absurd, so the sets are disjoint. On the
        other hand, if $x \in (A \setdif B) \cup (A \cap B) \cup (B \setdif A)$,
        then we have three possibilities: Whenever $x \in A \setdif B$, we have
        $x \in A$, and so $x \in A \cup B$; when $x \in A \cap B$, we obviously
        have $x \in A$, so $x \in A \cup B$; and if $x \in B \setdif A$, then $x
        \in B$, so $x \in A \cup B$, as desired. Now, if $x \in A \cup B$, then
        there are two possibilities: If $x \in A$, then either $x \in A$ and $x
        \in B$, in which case $x \in A \cap B$, or $x \in A$ and $x \not\in B$,
        in which case $x \in A \setdif B$; both of these cases yield $x \in (A
        \setdif B) \cup (A \cap B) \cup (B \setdif A)$ by definition of pairwise
        union. Similarly, if $x \in B$, then either $x \in A \cap B$ or $x \in B
        \setdif A$, so $x \in (A \setdif B) \cup (A \cap B) \cup (B \setdif A)$.
\end{proof}

\begin{exercise}
        Show that the axiom of replacement implies the axiom of specification.
\end{exercise}
\begin{proof}
        It suffices to show that any set that can be constructed by the axiom of
        specification can be constructed by just the axiom of replacement. To
        begin with, we need to establish a property $Q$ pertaining to two
        objects $x, y$. We define such a property to be $P(x)$ and $x = y$,
        i.e.,
        \[
                Q(x,y) \iff P(x) \text{ and } x = y.
        \] 
        Now we want to prove that, for an arbitrary set $A$,
        \[
                \{y : Q(x,y) \text{ for some } x \in A\} = \{x \in A : P(x)\}.  
        \] 
        So as to prove this equality, we show two implications:
        \begin{itemize}
                \item Suppose that $z \in \{y : Q(x,y) \text{ for some } x \in
                        A\}$, which is to say $Q(x,z)$ is true, i.e., $P(x)$ is
                        true and $x = z$ for some $x \in A$. By the substitution
                        axiom, we then know that $P(z)$ and $z \in A$, but these
                        conditions are sufficient to claim $z \in \{x \in A :
                        P(x)\}$.
                \item Assuming $z \in \{x \in A : P(x)\}$, we have $z \in A$ and
                        $P(z)$. If we further define $z := x$, we then have
                        $P(x)$ and $x = z$ for some $x \in A$. Hence $z \in \{y
                        : Q(x,y) \text{ for some } x \in A\}$.
        \end{itemize}
        This completes the proof.
\end{proof}
